#! /usr/bin/perl -w

use strict;

#	This scripts compares the constraint weights of two grammar files
#	and outputs any constraints which have differing weights in the 
#	two grammar files.
#   It also outputs the constraints which have only been defined in one
#   of the two grammar files to operate on.
#
# Invocation arguments:
# 	1. grammar file 1
#	2. grammar file 2

open FILE_1, "<", $ARGV[ 0 ] or die "Could not open the first file.";
open FILE_2, "<", $ARGV[ 1 ] or die "Could not open the second file.";

my %constraint_weights_1;
my %constraint_weights_2;

while ( <FILE_1> )
{
	$constraint_weights_1{ $1 } = $2, "\n" if /\{.*\}.*?'(.+)' .*: (\d(?:\.\d+)?)/;
}

while ( <FILE_2> )
{
	$constraint_weights_2{ $1 } = $2, "\n" if /\{.*\}.*?'(.+)' .*: (\d(?:\.\d+)?)/;
}

for my $name ( keys %constraint_weights_1 )
{
    if ( defined $constraint_weights_2{ $name } )
    {
        if( $constraint_weights_1{ $name } != $constraint_weights_2{ $name } )
        {
            print $name, "\n", "File 1: $constraint_weights_1{ $name }", "\n", "File 2: $constraint_weights_2{ $name }", "\n" x 2;
        }
        delete $constraint_weights_2{ $name };
    }
    else
    {
        print "The constraint '", $name, "' is not defined in file 2.\n";
    }
}

for ( keys %constraint_weights_2 )
{
    print "The constraint '", $_, "' is not defined in file 1.\n";
}