package cia_components.reasoning;

import edu.stanford.smi.protegex.owl.inference.protegeowl.log.ReasonerLogger;
import edu.stanford.smi.protegex.owl.inference.protegeowl.log.ReasonerLoggerListener;
import edu.stanford.smi.protegex.owl.inference.protegeowl.log.ReasonerLogRecord;
import edu.stanford.smi.protegex.owl.inference.protegeowl.log.MessageLogRecord;

import java.io.*;
import java.util.*;
import java.net.*;

public class DIG_Logger
{	
	public DIG_Logger()
	{							
		ReasonerLoggerListener listener = new ReasonerLoggerListener() 
		{
			public void logRecordPosted( ReasonerLogRecord reasonerLogRecord ) 
			{
				if( reasonerLogRecord instanceof MessageLogRecord ) 
				{
					MessageLogRecord msgLog = ( MessageLogRecord ) reasonerLogRecord;
					log_to_File( msgLog.getMessage() );
				}
			}
		};		
		ReasonerLogger.getInstance().addListener( listener );
	}
	
	
	public void log_to_File( String message )
	{
		String fileName = System.getenv( "DIG_LOG_FILE" );
    	
    	try
        {
            FileWriter fw = new FileWriter( fileName );
            BufferedWriter bw = new BufferedWriter( fw );
            PrintWriter pw = new PrintWriter( bw );
            pw.println( message );
            pw.flush();
            pw.close(); 
        }    
        catch ( IOException e )
        {
            System.err.println( e );
        }
    }
}