# usr/bin/perl -w

use strict;

# 	This script compares the lexical entries in to files and examines whether the perfect auxiliaries listed
#	for each verb are identical.
#
# 	Invocation arguments:
# 	1. file_1 to compare which should be a subset of the second file
#	2. file_2 to compare which should be a superset of the first file


open FILE_1, "<", my $file_1 = $ARGV[ 0 ];
open FILE_2, "<", my $file_2 = $ARGV[ 1 ];

my $agreement;
my $verb_1;

my $verb_2;

while ( <FILE_1> )
{
	my $perfect_1 = "-";
	my $perfect_2 = "-";
    	next unless /^([\w]+)\s*:=.*perfect:(\w+)/;
    	
    	print $verb_1 = $1;
   	$perfect_1 = $2;
    	
    	until ( $verb_2 eq $verb_1 )
    	{
		my $line_2 = <FILE_2>;    	
    		$verb_2 = $1 if $line_2 =~/^([\w]+)\s*:=.*perfect:(\w+)/;
   		$perfect_2 = $2;
   	}
   	
   	if ( $perfect_1 ne $perfect_2 )
   	{
		printf "\n%-25s%s\n%-25s%s\n\n", "CDG Lexicon Perfect:", $perfect_1, "CDG2 Lexicon Perfect: ", $perfect_2;
	}
	else
	{	
		printf "Perfect auxiliaries for $verb_1 and $verb_2 agree.\n\n";
	}
}
