#! /usr/bin/perl -w

# 	This script lists all verb definitions from Verben.txt that have the semantic valence
#	$in but not the semantic valence $out.

use strict;

# If only one in-valence is to be specified, set $in1 = $in2 = $in3.
my $in1 = "ag";
my $in2 = "ag";
my $in3 = "ag_re_th";

# If only one out-valence is to be specified, set $out1 = $out2 = $out3.
my $out1 = "ag_th";
my $out2 = "ag_th";
my $out3 = "ag_th";

my %syntactic_valences;
my %semantic_valences;
my %semantic_valence_count;
my %word_count;

while ( <> )
{
	if ( /verb (.+?)\s+.* ([^ ]+) sem_val:([a-z_]+) / )
	{		
		$syntactic_valences{ $1 }{ $2 } ++;	
		print "Added $1 with $2.\n";

		$semantic_valences{ $1 }{ $3 } ++;	
		# print "Added $1 with $2.\n";
				
		$word_count{ $1 } ++;
		$semantic_valence_count{ $3 } ++;
	}
}

for my $key ( sort keys %semantic_valences )
{
	if ( $semantic_valences{ $key }{ $in1 } && $semantic_valences{ $key }{ $in2 } && $semantic_valences{ $key }{ $in3 } && ! $semantic_valences{ $key }{ $out1 } && ! $semantic_valences{ $key }{ $out2 } && ! $semantic_valences{ $key }{ $out3 } )
	{
		print "The verb $key was defined to have thematic semantic_valences $in1, $in2 and $in3 but NOT $out1, $out2 or $out3.\n";
	}	
}


print "Semantic semantic_valences were defined for a total of ", scalar keys %word_count, " unique verbs.\n";

for my $key ( keys %semantic_valence_count )
{
	print "$key \t $semantic_valence_count{ $key } \n";
}


