#! /usr/bin/perl -w

use strict;
use locale;

# 	This script modifies the input file in which blocks of semantic valence definitions are followed 
#	by an avz_definition followed by a blank line.
#   In the output file the avz_valence line precedes the semantic valence definition block which is 
#	then followed by a blank line.
#
#   Invocation Arguments
#   ====================
#
#   1. Semantic Valence definition file to process (./Semantic.Valences by default).
#

open INPUT, "<", shift @ARGV || "Semantic.Valences";

my @lines;

while ( <INPUT> )
{
    next if ( /^$/ );
    
    if ( /avz_valence/ )
    {
        print $_, @lines, "\n";
        @lines = ();
    }
    else
    {
        push @lines, $_;
    }
}