/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <blah.h>
#include <string.h>

//#define VERBOSE

int main(int argc, char **argv)
{
  String str1 = NULL;
  String str2 = NULL;
  int i, n;
  
  blahInitialize();

  str1 = strRegister("Hello World");
  str2 = strRegister("Hello World");
  
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif

  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 == str2);

//  strDelete(str1);
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 == str2);

  str1 = strRegister(str2);
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 == str2);

  str1 = strCopy(str2);
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 != str2);
  memFree(str1);
  strDelete(str2);

  for (i = 0; i < 20; i++) {
    str1 = strPrintf("%d", i % 10);
    assert(str1 != NULL);
#ifdef VERBOSE
    printf("str1='%s', pointer=%p\n", str1, str1);
#endif
    sscanf(str1, "%d", &n);
    assert(n == (i % 10));
    strDelete(str1);
  }

  /* test the decoding function */
  assert(strcmp(strDecode("äöüÄÖÜß"), "") == 0); // utf8 to iso
  assert(strcmp(strDecode(""), "") == 0); // iso to iso
  assert(strcmp(strDecode("aeiouAEIOU"), "aeiouAEIOU") == 0); // iso to iso

  blahFinalize();
  return 0;
}
