/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include <assert.h>
#include <string.h>
#include <blah.h>

//#define VERBOSE

int main(int argc, char **argv)
{
  String str, str2;

  blahInitialize();

  str = strPrintf("%s %s", "Hello", "World");
#ifdef VERBOSE
  printf("str=%s pointer=%p\n", str, str);
#endif
  assert(strcmp(str, "Hello World") == 0);

  str = strPrintf("%d", 4711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4711") == 0);

  str = strPrintf("%4.3e", 4.711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4.711e+00") == 0);

  str = strPrintf("%f", 4.711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4.711000") == 0);

  str = strPrintf("%g", 4.711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4.711") == 0);

  str = strPrintf("%s", "Hello");
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "Hello") == 0);
  str2 = strPrintf("%s %s", str, "World");
#ifdef VERBOSE
  printf("str=%s, pointer=%p\n", str, str);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
#if 0
  assert(strcmp(str, "Hello World") == 0);
#endif

  blahFinalize();
  return 0;
}
