#!/bin/sh
# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

CDGP=cdgp

COMPILEARGS=""
VERBOSITYLEVEL=1
DEVNULL=""

while getopts o:chvq c
do
  case $c in 
    o)		COMPILEARGS="$COMPILEARGS -$c $OPTARG" ;;
    h | c)	COMPILEARGS="$COMPILEARGS -$c" ;;
    v)		VERBOSITYLEVEL=$[$VERBOSITYLEVEL + 1];;
    q)		DEVNULL=">/dev/null 2>&1"
  esac
done
shift `expr $OPTIND - 1`

GRAMMARFILES=$*
  
ERROR="on"
INFO="off"
WARNING="off"
PROFILE="off"
DEBUG="off"

[[ $VERBOSITYLEVEL > 0 ]] && ERROR="on"
[[ $VERBOSITYLEVEL > 1 ]] && INFO="on"
[[ $VERBOSITYLEVEL > 2 ]] && WARNING="on"
[[ $VERBOSITYLEVEL > 3 ]] && PROFILE="on"
[[ $VERBOSITYLEVEL > 4 ]] && DEBUG="on"

echo "
  set edges off
  set searchresult off
  set cache off
  set info $INFO
  set error $ERROR
  set warning $WARNING
  set profile $PROFILE
  set debug $DEBUG
  load $GRAMMARFILES
  compile $COMPILEARGS
" | eval $CDGP -i none $DEVNULL
