# Copyright (C) 1997-2007 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## Nmaespace CdgOption - access options of cdg
##
## Options in cdg are called cdg-options or variables. Cdg 
## cannot be accessed a second time during computation, but
## we like to know the value of the options during computation.
## For this reason the options are saved in the namesspace CdgOption.
##
## \author Yvonne Kuestermann
## (see also AUTHORS and THANKS for more)
##
## ----------------------------------------------------------------------------

namespace eval CdgOption {

  ## ----------------------------------------------------------------------
  ## Set the option
  ## ----------------------------------------------------------------------
  proc setOption {cdgOption value} {
    variable $cdgOption $value
  }

  ## ----------------------------------------------------------------------
  ## Get the value of the option
  ## ----------------------------------------------------------------------
  proc getOption {cdgOption} {
    variable $cdgOption

    # if the option was set, return it
    if { [ info exists $cdgOption ] } {
      eval return $$cdgOption
    }

    # if not, return false
    # TODO: check whether this behavior is right:
    #       perhaps sometimes a variable is set without using cmd::Set?
    return false
  }

}
