#!/bin/sh
#\
exec wish "$0" "$@" 

# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

#----------------------------------------------------------------------------
# set the environment
#----------------------------------------------------------------------------

#----------------------------------------------------------------------------
# load additional packages
#----------------------------------------------------------------------------
package require Iwidgets
catch {namespace import -force itcl::*}

# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------

wm withdraw .

set env(YADA_LIB) /home/micha/Projekt/cdg/yada

# the yada lib in YADA_LIB
if {![info exists env(YADA_LIB)]} {
  set env(YADA_LIB) [file join $env(YADA_PATH) lib]
} 
if {![file exists $env(YADA_LIB)]} {
  set env(YADA_LIB) [pwd]
  puts "ERROR: yada installation not found"
  puts "       please set the YADA_LIB environment variable"
  puts "       or link it to [file join $env(YADA_PATH) lib]"
  exit 1
}

# the yada images in YADA_IMAGES
if {![info exists env(YADA_IMAGES)]} {
  set env(YADA_IMAGES) [file join $env(YADA_LIB) images]
}
if {![file exists $env(YADA_IMAGES)]} {
  puts "ERROR: can't locate the yada images"
  puts "       please set the YADA_IMAGES environment variable"
  puts "       or link them to [file join $env(YADA_LIB) images"
  exit 1
}

source $env(YADA_LIB)/YadaOptions.tcl
lappend auto_path $env(YADA_LIB)


set fs [FileSelector .fs \
  -title "Select a file" \
  -width 500 \
  -height 400 \
  -filter {"*.tcl" "*.c" "*.h" "*.c *.h"} \
  -mode "multifile" \
  -master ""]

source $env(YADA_LIB)/bugfixes.tcl
 

# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------

# ----------------------------------------------------------------------------
while {[set selection [$fs activate -directory ~]] != ""} {
  puts "selection=`$selection'"
  puts "--------------------------------------------------------------------"
}
exit
